/*
 * Copyright (C) 2011 Atmark Techno, Inc. All Rights Reserved.
 */

/*
 * The code contained herein is licensed under the GNU General Public
 * License. You may obtain a copy of the GNU General Public License
 * Version 2 or later at the following locations:
 *
 * http://www.opensource.org/licenses/gpl-license.html
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef __ASM_ARCH_MXC_BOARD_ARMADILLO400_H__
#define __ASM_ARCH_MXC_BOARD_ARMADILLO400_H__

#include "armadillo400_iomux.h"

/* UART 1 configuration */
/* This define is used to enable or disable a particular UART port. If
 * disabled, the UART will not be registered in the file system and the user
 * will not be able to access it. There exists a define like this for each UART
 * port. Specify a value of 1 to enable the UART and 0 to disable it.
 */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART1)
#define UART1_ENABLED		1
#else
#define UART1_ENABLED		0
#endif
/*
 * This option allows to choose either an interrupt-driven software controlled
 * hardware flow control (set this option to 0) or hardware-driven hardware
 * flow control (set this option to 1).
 */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART1_HW_FLOW)
#define UART1_HW_FLOW           1
#else
#define UART1_HW_FLOW           0
#endif
/* This define specifies if the UART port is configured to be in DTE or
 * DCE mode. There exists a define like this for each UART port. Valid
 * values that can be used are \b MODE_DTE or \b MODE_DCE.
 */
#define UART1_MODE		MODE_DTE
/* This define specifies if the UART is to be used for IRDA. There exists a
 * define like this for each UART port. Valid values that can be used are
 * \b IRDA or \b NO_IRDA.
 */
#define UART1_IR		NO_IRDA
/*
 * This is option to enable (set this option to 1) or disable DMA data transfer
 */
#define UART1_DMA_ENABLE        0
/* UART 2 configuration */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART2)
#define UART2_ENABLED		1
#else
#define UART2_ENABLED		0
#endif
#if defined(CONFIG_ARMADILLO400_SELECTED_UART2_HW_FLOW)
#define UART2_HW_FLOW           1
#else
#define UART2_HW_FLOW           0
#endif
#define UART2_MODE		MODE_DTE
#define UART2_IR		NO_IRDA
#define UART2_DMA_ENABLE        0
/* UART 3 configuration */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART3)
#define UART3_ENABLED		1
#else
#define UART3_ENABLED		0
#endif
#if defined(CONFIG_ARMADILLO400_SELECTED_UART3_HW_FLOW)
#define UART3_HW_FLOW           1
#else
#define UART3_HW_FLOW           0
#endif
#define UART3_MODE		MODE_DTE
#define UART3_IR		NO_IRDA
#define UART3_DMA_ENABLE        0
/* UART 4 configuration */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART4)
#define UART4_ENABLED		1
#else
#define UART4_ENABLED		0
#endif
#if defined(CONFIG_ARMADILLO400_SELECTED_UART4_HW_FLOW)
#define UART4_HW_FLOW           1
#else
#define UART4_HW_FLOW           0
#endif
#define UART4_MODE		MODE_DTE
#define UART4_IR		NO_IRDA
#define UART4_DMA_ENABLE        0
/* UART 5 configuration */
#if defined(CONFIG_ARMADILLO400_SELECTED_UART5)
#define UART5_ENABLED		1
#else
#define UART5_ENABLED		0
#endif
#if defined(CONFIG_ARMADILLO400_SELECTED_UART5_HW_FLOW)
#define UART5_HW_FLOW           1
#else
#define UART5_HW_FLOW           0
#endif
#define UART5_MODE		MODE_DTE
#define UART5_IR		NO_IRDA
#define UART5_DMA_ENABLE        0

/* Named GPIO */
#define UART2_FORCEOFF_GPIO	GPIO(4, 31)

#define I2C1_CLK_GPIO		GPIO(1, 12)
#define I2C1_DAT_GPIO		GPIO(1, 13)
#define I2C2_CLK_GPIO		GPIO(1, 2)
#define I2C2_DAT_GPIO		GPIO(1, 3)
#define I2C3_CLK_GPIO		GPIO(1, 0)
#define I2C3_DAT_GPIO		GPIO(1, 1)

#define SDHC1_CLK_GPIO		GPIO(2, 24)
#define SDHC1_CD_GPIO		GPIO(3, 31)
#define SDHC1_PWREN_GPIO	GPIO(3, 27)
#define SDHC2_CLK_GPIO		GPIO(1, 6)
#define SDHC2_CD_GPIO		GPIO(4, 21)
#define SDHC2_WP_GPIO		GPIO(1, 7)
#define SDHC2_PWREN_GPIO	GPIO(3, 17)

#define FEC_LINK_LED_GPIO	GPIO(3, 16)
#define FEC_PHY_RST_GPIO	GPIO(3, 18)

#define PWM1_GPIO		GPIO(1, 26)

#define USB_PWRSEL_GPIO		GPIO(3, 26)
#endif
